/*
** Copyright R-U-ON, 2006
** www.r-u-on.com
*/

#include <ciao.h>
#include "cfw.h"
#include <stdio.h>
#include <string.h>

static int agentinit()
{
	printf("init callback\n");
	return 5;
}

static int agentmain(iao_agentinfo *agent, char *verb, char *x, int mode)
{
	if (mode==MODE_CONFIG_CHANGED)
	{
		iao_alarm alarms[256];
		int count=0;

		char *resources = iao_configresourcelist();
		while (resources!=NULL && *resources!=0)
		{
			alarms[count].type = 'A';
			strcpy(alarms[count].resource, iao_configresourcevalue(resources, "Resource"));
			sprintf(alarms[count].description, "%s %s %s", 
				iao_configresourcevalue(resources, "Description"),
				iao_configvalue("Param1"), iao_configvalue("Param2"));
			strcpy(alarms[count].id, "ID");
			alarms[count].severity = 'M';
			count++;
			resources+=(strlen(resources)+1);
		}
		return iao_alarms(agent, alarms, count, 0, verb, x);
	}
	else
	{
		return 1;
	}
}

agentmetadata getagentinfo() 
{
	static agentmetadata meta;
	static iao_confparam agentparams[] = {
		{"Param1", "String", "PPP1"},
		{"Param2", "String", "PPP2"},
		{0}
	};
	static iao_confparam resourceparams[] = {
		{"Resource", "String", "Resource"},
		{"Description", "String", "Description"},
		{0}
	};

	meta.Name = "TestAgent";
	meta.name = "testagent";
	meta.type = "msol.testagent";
	meta.version = "1.0";
	meta.agentparams = agentparams;
	meta.resourceparams = resourceparams;
	meta.agentregister = NULL;
	meta.agentinit = agentinit;
	meta.agentmain = agentmain;

	return meta;
}
