#ifndef CFW_H
#define CFW_H

#include "ciao.h"

typedef struct {
	char *Name; /* nice name */
	char *name; /* agent id name */
	char *type; /* agent type (unique) */
	char *version; /* agent version */
	iao_confparam *agentparams; /* parameters meta data array. NULL term. can be NULL */
	iao_confparam *resourceparams; /* managed resource array. NULL term. can be NULL */
	void (*agentregister)(iao_agentinfo *agent); /* Called once after successful agent resiger */
	int (*agentinit)(iao_agentinfo *agent); /* <0 die, 0 5 min main call, >0 freq of main call seconds */
	int (*agentmain)(iao_agentinfo *agent, char *verb, char *x, int mode); 
		/*<0 Couldn't communicate (mode will stick to next time) */
		/*0 communicated and verb is full */
		/*1 no communication was neccessary*/
} agentmetadata;

#define MODE_CONFIG_CHANGED 0x01

agentmetadata getagentinfo();

#endif
