/*
** Copyright R-U-ON, 2006
** www.r-u-on.com
*/

#ifdef WIN32
#include <windows.h>
#include <shlobj.h>
#include <process.h>
#include "service.h"
#pragma warning(disable : 4996)
#else
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#endif

#include <stdio.h>
#include "install.h"
#include "common.h"

char *AgentName();
char *agentname();

int rmfile(char *dir, char *name)
{
	char fname[MAX_PATH];
	sprintf(fname, "%s%s", dir, name);
	return unlink(fname);
}
void rmAllFiles(char *dir)
{
	char buff[256];
	sprintf(buff, "%s.log", agentname());
	rmfile(dir, buff);
	sprintf(buff, "%s.id", agentname());
	rmfile(dir, buff);
	rmfile(dir, "upgrade.exe");
	rmfile(dir, "upgrade");
	rmfile(dir, "config.dat");
}


#ifdef WIN32
int loadAtStartup(char *path)
{
	HKEY skey;
	LONG size = 1024;
	char *regpath = "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run";

	LONG ret = RegCreateKeyExA(HKEY_LOCAL_MACHINE, regpath, 0, NULL, REG_OPTION_NON_VOLATILE,
				   KEY_SET_VALUE, NULL,  &skey, NULL);
	if (ret!=ERROR_SUCCESS) 
	{
		logsysmsgforce("loadAtStartup: Failed openning registry key", ret);
		return -1;
	}

	if (path!=NULL)
	{
		char buff[256];
		sprintf(buff, "ruon.%s", agentname());
		ret = RegSetValueExA(skey, buff, 0, REG_SZ, path, (DWORD)strlen(path));
		if (ret!=ERROR_SUCCESS) 
		{
			logsysmsgforce("loadAtStartup: Failed writing value entry", ret);
			RegCloseKey(skey);
			return -1;
		}
	}
	else
	{
		char buff[256];
                sprintf(buff, "ruon.%s", agentname());
		ret = RegDeleteValueA(skey, buff);
		if (ret!=ERROR_SUCCESS) 
		{
			logsysmsgforce("loadAtStartup: Failed removing entry", ret);
			RegCloseKey(skey);
			return -1;
		}

	}
	RegCloseKey(skey);
	return 0;
}

int upgrade2()
{
	char myfname[MAX_PATH*2];
	char fname[MAX_PATH*2];
	int i;
	int ret;

	iao_logmsg("upgrade2: tmp bin running - writing agent image");

	sprintf(myfname, "%s/%s", getdir(), getexefile());
	sprintf(fname, "%s/%s.exe", getdir(), agentname() );

	for (i=0;i<60 && ((ret=copyfile(myfname, fname))!=0);++i)
	{
		Sleep(1000);
		iao_logmsg("upgrade2: Retrying...");
	}
	if (ret!=0)
	{
		iao_logmsg("upgrade2: Failed - couldn't write destination file");
	}
	else
	{
		iao_logmsg("upgrade2: image written. executing...");
	}
	GoService();
	return 0;
}

int install()
{
	char buff[MAX_PATH*2];
	int ret;

	if (stricmp(getexefile(), "upgrade.exe")==0)
	{
		upgrade2();
		return 0;
	}

	ret = IsServiceInstalled();
	if (ret==1)
	{
		return 0;
	}
	if (ret==-1) 
	{
		return -1;
	}

	iao_logmsg("Installing agent...");

	if (!SUCCEEDED(SHGetFolderPathA(NULL, CSIDL_PROGRAM_FILES, NULL, SHGFP_TYPE_CURRENT, buff)))
	{
		iao_logsysmsg("install: Couldn't obtain 'Program Files' path");
		if (GetWindowsDirectoryA(buff, MAX_PATH)==0)
		{
			iao_logsysmsg("install: Couldn't obtain 'Windows' path");
			strcpy(buff, "c:\\");
		}
	}

	strcat(buff, "\\ruon.");
	strcat(buff, agentname());
	strcat(buff, "\\");
	if (stricmp(buff, getdir())==0)
	{
		iao_logmsg("install: File already in place (no copy neccessary)");
		strcat(buff, agentname());
		strcat(buff, ".exe");
	}
	else
	{
		char exe[MAX_PATH*2];
		
		CreateDirectoryA(buff, NULL);
		strcpy(exe, getdir());
		strcat(exe, getexefile());
		strcat(buff, agentname());
		strcat(buff, ".exe");
		if (copyfile(exe, buff)!=0)
		{
			iao_logmsg("install: copy file failed");
			iao_logmsg(exe);
			iao_logmsg("to");
			iao_logmsg(buff);
			return -1;
		}
		else
		{
			char b2[1024];
			sprintf(b2, "install: File copied to \"%s\"", buff);
			iao_logmsg(b2);
		}
	}

	return InstallService(buff);
}


int uninstall()
{
	char batfname[MAX_PATH*2];
	FILE *fd;

	loadAtStartup(NULL);
	rmAllFiles(getdir());

	if (GetTempPathA(MAX_PATH*2, batfname)==0)
	{
		iao_logsysmsg("uninstall: Couldn't obtain 'TEMP' path, neccessary to perform uninstall");
		return -1;
	}

	strcat(batfname, "\\u");
	strcat(batfname, agentname());
	strcat(batfname, ".bat");
	fd = fopen(batfname, "wt");
	if (fd==NULL)
	{
		iao_logsysmsg("uninstall: Can't create uninst.bat");
		return -1;
	}
	s2bs(getdir());
	fprintf(fd, "@echo off\n");
	fprintf(fd, "echo Uninstalling R-U-ON agent %s ...\n", AgentName() );
	fprintf(fd, "ping -w 1000 -n 10 127.0.0.1 > NUL\n");
	fprintf(fd, "del \"%s%s\"\n", getdir(), getexefile());
	fprintf(fd, "rmdir /q \"%s\"\n", getdir());
	fprintf(fd, "echo Done.\n", AgentName() );
	fprintf(fd, "ping -w 1000 -n 2 127.0.0.1 > NUL\n");
	fprintf(fd, "del %s\n", batfname);
	fclose(fd);

	Sleep(3000);


	spawn(batfname);

	if (UninstallService()==-1) 
	{
		iao_logsysmsg("Uninstall service failed");
	}
	exit(-1);
	return -1;
}

int upgrade(void *binary, int len)
{
	char fname[MAX_PATH];
	FILE *fd;
	sprintf(fname, "%supgrade.exe", getdir() );
	fd = fopen(fname, "wb");
	if (fd==NULL)
	{
		iao_logsysmsg("upgrade: Can't write binary");
		return -1;
	}
	fwrite(binary, 1, len, fd);
	fclose(fd);
	iao_logmsg("upgrade: tmp binary written. executing...");
	if (spawn(fname)==-1)
	{
		iao_logsysmsg("Can't run upgrade image");
		return -1;
	}
	if (ServiceStop()==0)
	{
		Sleep(5000);
	}
	else
	{
		iao_logmsg("upgrade: Couldn't stop service");
	}
	exit(-1);
	return -1;
}

#else

int rotateupgrade(void *binary, int len)
{
	char fname[MAX_PATH];
	char buff[MAX_PATH*4];
	FILE *fd;
	sprintf(fname, "%supgrade", getdir());
	fd = fopen(fname, "wb");
	if (fd==NULL)
	{
		iao_logsysmsg("rotateupgrade: Can't write binary");
		return -1;
	}
	fwrite(binary, 1, len, fd);
	fclose(fd);
	iao_logmsg("rotateupgrade: new binary written. executing...");

	sprintf(buff, "chmod +x \"%supgrade\" ; rm \"%s%s\" ; mv \"%supgrade\""
                      " \"%s%s\" ; \"%s%s\"",
	        getdir(), getdir(), getexefile(), getdir(),
		getdir(), getexefile(), getdir(), getexefile());

        execl("/bin/sh", "/bin/sh", "-c", buff, NULL);

	iao_logsysmsg("rotateupgrade: execute failed");
	return -1;
}

int upgrade(void *binary, int len)
{
        char fname[MAX_PATH];
        FILE *fd;
        sprintf(fname, "%s%s", getdir(), getexefile());
        fd = fopen(fname, "wb");
        if (fd==NULL)
        {
		/* Especially for unix systems that keeps the file locked */
		iao_logmsg("upgrade: attempting rotateupgrade");
                return rotateupgrade(binary, len);
        }
        fwrite(binary, 1, len, fd);
        fclose(fd);
        iao_logmsg("upgrade: new binary written. executing...");
        execute(fname);
        iao_logsysmsg("upgrade: execute failed. Attempting rotateupgrade");
	return rotateupgrade(binary, len);
}

static int createfile(char *dir, char*name, char *content, char *p1, char *p2)
{
	FILE *fd;
	char fname[MAX_PATH];
	sprintf(fname, "%s%s", dir, name);
	fd = fopen(fname, "wb");
	if (fd==NULL)
	{
		char buff[MAX_PATH];
		sprintf(buff, "Can't create %s", fname);
		iao_logsysmsg(buff);
		return -1;
	}
	fprintf(fd, content, p1, p2);
	fclose(fd);
	return 0;
}

static int createinitd()
{
	char *initdbuff = 
		"#!/bin/sh\n"
		"## init.d script for %1$s\n##\n##\n"
		"# chkconfig: 23456 99 30\n"
		"# description: %1$s monitoring agent from www.r-u-on.com\n"
		"#\n"
		"AGENT_PATH=/usr/local/ruon.%2$s/%2$s\n"
		"AGENT_NAME=%1$s\n"
                "if [ \"$NETWORKING\" = \"no\" ]; then\n"
                "        exit 0\n"
                "fi\n"
                "RETVAL=0\n"
                "start() {\n"
                "        /bin/echo \"Starting $AGENT_NAME...\"\n"
                "        $AGENT_PATH > /dev/null 2>&1 &\n"
                "}\n"
                "stop() {\n"
                "        killall -q $AGENT_PATH\n"
                "}\n"
                "status() {\n"
                "        pgrep -f $AGENT_PATH > /dev/null\n"
                "        RETVAL=$?\n"
                "        if [ $RETVAL -eq 0 ]; then\n"
                "                /bin/echo \"$AGENT_NAME is running :-)\"\n"
                "                return $RETVAL\n"
                "        fi\n"
                "        /bin/echo \"$AGENT_NAME is not running :-(\"\n"
                "        return $RETVAL\n"
                "}\n"
                "case \"$1\" in\n"
                "    start)\n"
                "        stop\n"
                "        start\n"
                "        sleep 1\n"
                "        status\n"
                "        ;;\n"
                "    stop)\n"
                "        /bin/echo \"Shutting down $AGENT_NAME...\"\n"
                "        stop\n"
                "        status\n"
                "        echo\n"
                "        ;;\n"
                "    status)\n"
                "        status\n"
                "        ;;\n"
                "    restart)\n"
                "        stop\n"
                "        start\n"
                "        ;;\n"
                "    *)\n"
                "        echo $\"Usage: $0 {start|stop|status}\"\n"
                "        ;;\n"
                "esac\n";

	return createfile(getdir(), "initdfile.tmp", initdbuff, AgentName(), agentname());
}

static int linuxuninstallscript(char *type)
{
	char *script[][2] = {
		{"R",	"/sbin/service ruon.%1$s stop\n"
		       	"/sbin/chkconfig --del ruon.%1$s\n"
			"\\rm /etc/init.d/ruon.%1$s\n"
			"\\rm -rf /usr/local/ruon.%1$s\n"
			"echo \"Agent uninstalled successfuly\"\n"},

		{"D", 	"/usr/sbin/invoke-rc.d ruon.%1$s stop\n"
		       	"/usr/sbin/update-rc.d -f ruon.%1$s remove\n"
			"\\rm /etc/init.d/ruon.%1$s\n"
			"\\rm -rf /usr/local/ruon.%1$s\n"
			"echo \"Agent uninstalled successfuly\"\n"},
		{NULL, NULL}
		};
	char **s = script[0];

	while (strstr(s[0], type)==NULL)
	{
		s+=2;
		if (s[0]==NULL)
		{
			printf("linuxuninstallscript: internal problem\n");
			return -1;
		}
	}

	return createfile(getdir(), "uninstall.sh", s[1], agentname(), "");
}

static int exitstatus(int s)
{
	return (s & 0xFF00)>>8;
}

static char *determineinitd()
{
	if (exitstatus(system("/sbin/service >/dev/null 2>&1"))!=127 &&
	    exitstatus(system("/sbin/chkconfig >/dev/null 2>&1"))!=127)
	{
		return "R"; /* REDHAT */
	}
	if (exitstatus(system("/usr/sbin/update-rc.d >/dev/null 2>&1"))!=127 &&
	    exitstatus(system("/usr/sbin/invoke-rc.d >/dev/null 2>&1"))!=127)
	{
		return "D"; /* DEBIAN */
	}
	return NULL;
}

int install(void)
{
	char *cmd[][6] = {
		{"RD", "This installation method is for Linux only", "uname | grep Linux > /dev/null", "", "", ""},
		{"RD", "Must have root permissions to install", "id -un | grep root > /dev/null", "", "", ""},
		{"RD", "", "mv %sinitdfile.tmp /etc/init.d/ruon.%s", getdir(), agentname(),  ""},
		{"RD", "", "chmod a+x /etc/init.d/ruon.%s", agentname(), "", ""},
		{"RD", "", "mkdir /usr/local/ruon.%s", agentname(), "", ""},
		{"RD", "", "mv %suninstall.sh /usr/local/ruon.%s", getdir(), agentname(), ""},
		{"RD", "", "chmod u+x /usr/local/ruon.%s/uninstall.sh", agentname(), "", ""},
		{"RD", "", "cp %s%s /usr/local/ruon.%s/%3$s", getdir(), getexefile(), agentname()},
		{"R",  "", "/sbin/chkconfig --add ruon.%s", agentname(), "", ""},
		{"R",  "",  "/sbin/service ruon.%s start", agentname(), "", ""},
		{"D",  "",  "/usr/sbin/update-rc.d ruon.%s defaults", agentname(), "", ""},
		{"D",  "",  "/usr/sbin/invoke-rc.d ruon.%s start", agentname(), "", ""},
		{NULL, NULL, NULL, NULL, NULL, NULL}
	};
	char **c = cmd[0];
	char *type;
	printf("Installing...\n");
	type = determineinitd();
	if (type==NULL)
	{
		printf("Unknown init.d utility (I support chkconfig and update-rc.d)\n");
		return -1;
	}
	if (createinitd()!=0 || linuxuninstallscript(type)!=0)
	{
		return -1;
	}
	while (c[0]!=NULL)
	{
		if (strstr(c[0], type)!=NULL)
		{
			char buff[MAX_PATH];
			sprintf(buff, c[2], c[3], c[4], c[5]);
			if (system(buff)!=0)
			{
				if (c[1][0]==0)
				{
					printf("Last command: %s\n", buff);
				}
				else
				{
					printf("%s\n", c[1]);
				}
                		printf("Installation failed\n");
				return -1;
			}
		}
		c+=6;
	}
	return 0;
}

int uninstallscript()
{
	char path[MAX_PATH];
	FILE *fd;

	sprintf(path, "%s%s", getdir(), "uninstall.sh");
	fd = fopen(path, "rb");
	if (fd!=NULL)
	{
		fclose(fd);
		spawn(path);
		return 1;
	}
	else
	{
		return 0;
	}
}

int uninstall(void)
{
	if (uninstallscript())
	{
		sleep(60);
	}
	iao_logmsg("uninstall: Removing agent");
	rmAllFiles(getdir());
	if (rmfile(getdir(), getexefile())==0)
	{
		rmdir(getdir());
		printf("Agent uninstalled\n");
	}
	else
	{
		/* This is here for unix systems that locks executables */
		/* rmdir will only work if a directory (not '.'). tough. */
		char buff[MAX_PATH*3];
		sprintf(buff, "/bin/rm \"%s%s\" ; rmdir \"%s\"", getdir(), 
		        getexefile(), getdir() );
		execl("/bin/sh", "/bin/sh", "-c", buff, NULL);
	}
	bailout();
	return -1;
}
#endif

