/*
** Copyright R-U-ON, 2006
** www.r-u-on.com
*/

#ifdef WIN32
#define _WIN32_WINNT 0x0501
#include <windows.h>
#pragma warning(disable:4996)
#endif

#include <ciao.h>
#include <string.h>
#include <stdio.h>
#include <time.h>

#include "common.h"
#include "cfw.h"

int agentinit(iao_agentinfo *agent);
int agentmain(iao_agentinfo *agent, char *verb, char *x, int mode);

agentmetadata getagentinfo()
{
	static agentmetadata meta;
	meta.Name = "OnTouch";
	meta.name = "ontouch";
	/* When writing your own private agent don't add the ruon prefix to its type name. */
	/* This way you are certain to maintain name uniqueness. */
	meta.type = "ruon.OnTouch";
	meta.version = "1.1";
	meta.agentparams = NULL;
	meta.resourceparams = NULL;
	meta.agentregister = NULL;
	meta.agentinit = agentinit;
	meta.agentmain = agentmain;
	return meta;
}



DWORD last=0;
int isactive()
{
	int active = 0;
	LASTINPUTINFO info;
	info.cbSize = sizeof(LASTINPUTINFO);

	if (!GetLastInputInfo(&info))
	{
		iao_logsysmsg("isactive: GetLastInputInfo failed!");
		return 0;
	}

	active = last!=info.dwTime && last!=0;
	last = info.dwTime;
	return active;
}

int agentinit(iao_agentinfo *agent)
{
	return 5;
}

int sendalarm(iao_agentinfo *agent, iao_alarm *alarm, char *verb, char *x)
{
	strcpy(alarm->resource, "Server");
	strcpy(alarm->id, "CONSOLE_TOUCHED");

	return iao_alarms(agent, alarm, 1, 1, verb, x);
}

int reportalarm(iao_agentinfo *agent, char *verb, char *x)
{
	iao_alarm alarm;
	alarm.type = 'A';
	alarm.severity = 'M';
	strcpy(alarm.description, "Server is being accessed via the mouse or keyboard");

	return sendalarm(agent, &alarm, verb, x);
}

int reportclear(iao_agentinfo *agent, char *verb, char *x)
{
	iao_alarm alarm;
	alarm.type = 'C';
	strcpy(alarm.description, "Five minutes have elapsed since server was last touched");

	return sendalarm(agent, &alarm, verb, x);
}


static time_t last_touch = 0;
static int alarmon=-1;
int agentmain(iao_agentinfo *agent, char *verb, char *x, int mode)
{
	int active = isactive();
	if (active)
	{
		last_touch = time(NULL);
	}

	if (active==alarmon)
	{
		return 1;
	}
	else
	{
		if (!active && time(NULL)>last_touch+5*60)
		{
			int ret = reportclear(agent, verb, x);
			if (ret==0)
			{
				alarmon = active;
			}
			return ret;
		}
		if (active) 
		{
			int ret = reportalarm(agent, verb, x);
			if (ret==0)
			{
				alarmon = active;
			}
			return ret;
		}
		return 1;
	}
}
